%define shortname xgl
%define name    x11-server-xgl
%define version 0.0.1
%define subrel 3
%define rel     11
%define git     20060714

%if %{git}
%define release  %mkrel 0.%{git}.%{rel}
%define srcpath http://www.schokokeks.org/~hanno/snapshots/%{shortname}-%{git}.tar.bz2
%define distname %{shortname}
%else
%define release  %mkrel %{rel}
%define distname %{shortname}-%{version}
%define srcpath %{distname}.tar.bz2
%endif

%if %mdkversion <= 200600
%define xgldir          /opt/Xgl
%else
%define xgldir          %_prefix
%endif

Name:	 %{name}
Version: %{version}
Release: %{release}
Summary: Xserver that uses OpenGL
License: GPL
Group:   System/X11
Url:     http://www.freedesktop.org/wiki/Software/Xgl
Source0: %{srcpath}
Source1: xgl.xinit
Source2: xgl.sysconfig
# revert "Mesa CVS head" patches
# http://lists.freedesktop.org/archives/xorg/2006-April/014688.html
Patch0: xgl-bitset.patch
# http://lists.freedesktop.org/archives/xorg/2006-May/015526.html
Patch1: xgl-rbadaptors.patch
Patch2: xgl-xinerama.patch
# http://lists.freedesktop.org/archives/xorg-commit/2006-June/007764.html
Patch3: xgl-arrayobj.patch
# https://bugs.freedesktop.org/show_bug.cgi?id=7137
# patch adapted from opensuse
Patch4: xgl-XkbGetKeyboard.patch
Patch5: 0004-Blue-background-on-startup.txt
# Fix DPMS on Xgl #28873
Patch6: xgl-dpms_fix.patch
Patch7: xorg-git-CVE-2007-4730.patch
Patch8: xorg-x11-server-cve-2007-5760.patch
Patch9: xorg-x11-server-cve-2007-5958.patch
Patch10: xorg-x11-server-cve-2007-6427.patch
Patch11: xorg-x11-server-cve-2007-6428.patch
Patch12: xorg-x11-server-cve-2007-6429.patch

BuildRoot: %{_tmppath}/%{name}-build-root
%if %mdkversion > 200600
BuildRequires: libglitz-devel
BuildRequires: libfontenc-devel
BuildRequires: libxau-devel
BuildRequires: libxaw-devel
BuildRequires: libxdmcp-devel
BuildRequires: libxext-devel
BuildRequires: libxfont-devel
BuildRequires: libxi-devel
BuildRequires: libxkbfile-devel
BuildRequires: libxau-devel
BuildRequires: libxkbui-devel
BuildRequires: libxmu-devel
BuildRequires: libxpm-devel
BuildRequires: libxrender-devel
BuildRequires: libxres-devel
BuildRequires: libxxf86misc-devel
BuildRequires: libxxf86vm-devel
BuildRequires: libxfont-devel
BuildRequires: x11-proto-devel
BuildRequires: x11-util-macros
BuildRequires: x11-xtrans-devel
BuildRequires: libxrandr-devel
BuildRequires: libxinerama-devel
%endif
BuildRequires: mesa-source
Requires: mesa-demos
Requires: x11-server-xorg

%description
Xgl is an Xserver that uses OpenGL for its drawing operations. Some
operations like antialiased font rendering is noticably faster with
this technology, and future graphics hardware might only have support
for 3D operations and no 2D core any more.

Note that this is highly experimental code, it has been tested only on
few hardware platforms, and depending on driver state it may even crash
your computer.

%prep
%setup -q -n %{distname}
%patch0 -R -p0 -b .bitset
%patch1 -p1 -b .rbadaptors
%patch2 -b .xinerama
%patch3 -R -p1 -b .arrayobj
%patch4 -p0 -b .xkb
%patch5 -p1 -b .blue_bg
%patch6 -p1 -b .dpms_fix
%patch7 -p1 -b .cve-2007-4730
%patch8 -p1 -b .cve-2007-5760
%patch9 -p1 -b .cve-2007-5958
%patch10 -p1 -b .cve-2007-6427
%patch11 -p1 -b .cve-2007-6428
%patch12 -p1 -b .cve-2007-6429


%build
./autogen.sh	--prefix=%{xgldir} \
		--libdir=%{xgldir}/%{_lib} \
		--enable-xgl \
		--disable-xorg \
		--disable-xprint \
		--enable-glx \
		--enable-dri \
		--with-default-font-path="unix/:-1" \
		--with-mesa-source=/usr/src/Mesa/ \
		--disable-dmx \
		--disable-xvfb \
		--disable-xnest \
		--enable-xglx
%make

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std

# (blino) would conflict with x11-server-xorg
rm -f %{buildroot}%{xgldir}/man/man1/Xserver.1*
# (blino) would conflict with x11-server-devel
rm -f %{buildroot}%{xgldir}/%{_lib}/pkgconfig/xorg-server.pc
rm -f %{buildroot}%{xgldir}/share/aclocal/xorg-server.m4
# (blino) in x11-server-common
rm -f %{buildroot}%{xgldir}/%{_lib}/xserver/SecurityPolicy
rmdir %{buildroot}%{xgldir}/%{_lib}/xserver

install -D -m 0755 %SOURCE1 %{buildroot}%{_sysconfdir}/X11/xinit.d/01%{shortname}
install -D -m 0644 %SOURCE2 %{buildroot}%{_sysconfdir}/sysconfig/%{shortname}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{xgldir}/bin/Xgl*
%{xgldir}/%{_lib}/xorg/*
%{xgldir}/share/X11/xkb/compiled/README.compiled
%{_sysconfdir}/X11/xinit.d/01%{shortname}
%config(noreplace) %{_sysconfdir}/sysconfig/%{shortname}


%changelog
* Tue Jan 22 2008 Vincent Danen <vdanen@mandriva.com> 0.0.1-0.20060714.11.3mdv2007.0
- P8: security fix for CVE-2007-5760
- P9: security fix for CVE-2007-5958
- P10: security fix for CVE-2007-6427
- P11: security fix for CVE-2007-6428
- P12: security fix for CVE-2007-6429

* Tue Sep 11 2007 Vincent Danen <vdanen@mandriva.com> 0.0.1-0.20060714.11.2mdv2007.0
- P7: security fix for CVE-2007-4730

* Wed May 23 2007 Vincent Danen <vdanen@mandriva.com> 0.0.1-0.20060714.11.1mdv2007.0
- build for updates

* Tue May 15 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 0.0.1-0.20060714.11mdv2007.0
+ Revision: 27043
- Really disable DPMS in the underlying X server (not only when Xgl starts Xorg
  by itself) (#28873).

  + Andreas Hasenack <andreas@mandriva.com>
    -m imported updates from recovered svn


* Sat Apr 07 2007 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20070105.5mdv2007.1
+ Revision: 150915
- borrow Xwrapper from the Xorg package to run Xgl as root (and thus allow it to take over lock files, #24923, #27104)

* Mon Mar 19 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 0.0.1-0.20070105.4mdv2007.1
+ Revision: 146795
- Really disable DPMS in the underlying X server (not only when Xgl starts Xorg
  by itself) (#28873).

* Wed Mar 14 2007 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20070105.3mdv2007.1
+ Revision: 143564
- use configure rpm macro to fix datadir (and thus xkb...)

* Fri Mar 02 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 0.0.1-0.20070105.2mdv2007.1
+ Revision: 131571
- update the blue bg patch to fix an error of not properly telling X we have a
  bg color, and not a bg tile pixmap

* Tue Feb 13 2007 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20070105.1mdv2007.1
+ Revision: 120640
- update snapshot (20070105) for new Mesa (and drop merged patches)
- rename COMPOSITING_SERVER_OPTIONS as COMPOSITING_SERVER_ARGS
- remove unused variable
- move Xgl xinit.d and sysconfig files in compositing-server-common
- do not try to resolve names

* Fri Sep 15 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.9mdv2007.0
+ Revision: 61372
- don't use -ac option but add cookies for Xgl display instead (#24730)

* Fri Sep 08 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.8mdv2007.0
+ Revision: 60559
- remove LD_LIBRARY_PATH hack, only compiz requires it
- fix man page removal (section is not 1x anymore but 1)
- really disable Xgl in failsafe/drak3d sessions

  + Pixel <pixel@mandriva.com>
    - adapt background color (as requested by our graphic team)

* Sat Aug 26 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.6mdv2007.0
+ Revision: 58047
- fix typo in xinit.d script __LIBDIR__ replacement

* Fri Aug 25 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.5mdv2007.0
+ Revision: 57974
- increase release
- remove hardcoded Xgl path
- don't start compiz if in failsafe or drak3d session
- remove extra underscore in xinit script name
- do not enable Xgl by default
- add blue background patch from x11-server

* Wed Aug 23 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.4mdv2007.0
+ Revision: 57449
- x11-server-xgl-0.0.1-0.20060714.4mdv2007.0
- add missing buildrequires, so that the xglx module gets always built (Christiaan Welvaart)

* Tue Aug 22 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.3mdv2007.0
+ Revision: 56920
- x11-server-xgl-0.0.1-0.20060714.3mdv2007.0
- handle the no3ddesktop cmdline option
- allow to configure Xgl options
- allow to configure Xgl display
- add XkbGetKeyboard (needed for gnome keyboard tool)
- enable xkb
- don't start Xgl when both client and server GLX_EXT_tfp are present, not only server (fglrx fix)

* Sat Aug 19 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.2mdv2007.0
+ Revision: 56752
- x11-server-xgl-0.0.1-0.20060714.2mdv2007.0
- auto-start Xgl if possible and useful

* Thu Aug 17 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.1mdv2007.0
+ Revision: 56492
- mark the sysconfig file as config
- add url
- fix summary ended with dot
- add xgl-arrayobj.patch
- really use unix/:-1 as default font path
- export LD_LIBRARY_PATH
- remove unpackaged xserver directory
- really remove xorg-server.m4
- 64 bit fixes (Colin Guthrie)
- fix build with cooker's Mesa
- don't package xorg-server.m4
- use git snapshot
- add Xinerama support (Colin Guthrie)
- use unix/:-1 as default fontpath (Colin Guthrie)
- add buildrequires (Colin Guthrie)
- use xgl as shortname (Colin Guthrie)
- require x11-server-xorg (Christiaan Welvaart)
- add some missing buildroot
- SecurityPolicy is in x11-server-common (Christiaan Welvaart)
- don't package pkgconfig file (Christiaan Welvaart)
- don't package Xserver man page (Christiaan Welvaart)
- rename xgl as x11-server-xgl (Christiaan Welvaart)
- require mesa-demos (#24335)

* Fri Aug 11 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060808.1mdv2007.0
+ Revision: 55443
- really add xgl session files
- allow to run XGL from X session (config in /etc/sysconfig/xgl)
- fix typo
- fix man page in files list
- fix typo
- use make macro and clean buildroot
- xgl-0.0.1-20060808
- remove 2006.0 hacks
- remove 2006.0 hacks
- don't use prefix on cooker
- pass xgldir as prefix to configure script
- revert "Mesa CVS head" specific patches to build with cooker Mesa
- cooker updates (from Vincent Guardiola)
- import xgl-0.0.1-1mdv2007.0

